declare module 'Cpp'{
    namespace Cpp {
        interface PaymentMethod{

            /**
             * 
             */
             customerId: string;

            /**
             * RFC123 timestamp when the customer was created.
             */
            createdTimestamp: string;

            /**
             * RFC123 timestamp when the customer was modified.
             */
            modifiedTimestamp?: string | null;

            /**
             * 
             */
            paymentMethods?: Array<PaymentMethod.Details> | null;   
        }

        namespace PaymentMethod{
            interface Details{
                /**
                 * Types of payment method include: card
                 */
                paymentType: string;

                /**
                 * 
                 */
                tokens: object;

                /**
                 * 
                 */
                maskedCardNumber: string;

                /**
                 * 
                 */
                expiryMonth: string;

                /**
                 * 
                 */
                expiryYear: string;

                /**
                 * 
                 */
                cardType: string;

                /**
                 * 
                 */
                paymentMethodId: string;
            }
        }

        interface PaymentMethodQueryParams {
            /**
             * Customer id returned from Create Customer request.
             */
            customerId?: string;
    
            /**
             * Types of payment methods include: card.
             */
            paymentTypes?: Array<string>;
        }

        interface PaymentMethodDeleteParams {
            /**
             * Customer id returned from Create Customer request.
             */
            customerId?: string;
    
            /**
             * Payment method id returned from Create Session request.
             */
            paymentMethodId?: string;
        }

        class PaymentMethodsResource{
            /**
             * Queries customer's payment methods.
             */
            query(
                params?: PaymentMethodQueryParams,
                options?: RequestOptions
            ): Promise<Cpp.Response<Cpp.PaymentMethod>>;

            /**
             * Delete customer's payment method.
             */
             del(
                params?: PaymentMethodDeleteParams,
                options?: RequestOptions
            ): Promise;
        }
    }
}