// File generated from our OpenAPI spec

///<reference path='../lib.d.ts' />
///<reference path='../crypto/crypto.d.ts' />
///<reference path='../net/net.d.ts' />
///<reference path='../Errors.d.ts' />
///<reference path='./Customers.d.ts' />
///<reference path='./PaymentMethods.d.ts' />
///<reference path='./Payments.d.ts' />
///<reference path='./Sessions.d.ts' />


declare module 'cpp' {
    // Added to in other modules, referenced above.
    export namespace Cpp {}
  
    export class Cpp {
      static Cpp: typeof Cpp;
      
      constructor(merchantId: string, sharedSecret: string, config: Cpp.CppConfig);
  
      setAppInfo(info: Cpp.AppInfo): void;
  
      CppResource: Cpp.CppResource;
  
      /**
       * Top Level Resources
       */
      customers: Cpp.CustomersResource;
      paymentMethods: Cpp.PaymentMethodsResource;
      payments: Cpp.PaymentsResource;
      sessions: Cpp.SessionsResource;
  
      /**
       * API Errors
       */
      static errors: Cpp.Errors;
      errors: Cpp.Errors;
  
      on(event: 'request', handler: (event: Cpp.RequestEvent) => void): void;
      on(event: 'response', handler: (event: Cpp.ResponseEvent) => void): void;
      once(event: 'request', handler: (event: Cpp.RequestEvent) => void): void;
      once(
        event: 'response',
        handler: (event: Cpp.ResponseEvent) => void
      ): void;
      off(event: 'request', handler: (event: Cpp.RequestEvent) => void): void;
      off(
        event: 'response',
        handler: (event: Cpp.ResponseEvent) => void
      ): void;
  
      setProtocol(protocol: string): void;
    }
  
    export default Cpp;
  }
  